/*****************************************************************
 *****************************************************************
 ***                                                            **
 ***    (C)Copyright 2005-2006, American Megatrends Inc.        **
 ***                                                            **
 ***            All Rights Reserved.                            **
 ***                                                            **
 ***        6145-F, Northbelt Parkway, Norcross,                **
 ***                                                            **
 ***        Georgia - 30071, USA. Phone-(770)-246-8600.         **
 ***                                                            **
 *****************************************************************
 ******************************************************************
 *
 * fru.h
 * fru.c extern declarations
 *
 *  Author: Rama Bisa <govindk@ami.com>
 *
 ******************************************************************/

#ifndef FRU_H
#define FRU_H

#include <stdint.h>

/**
 * @defgroup fdc FRU Device Command handlers
 * @ingroup storage
 * IPMI Platform Management FRU (Field Replaceable Unit) information storage
 * interface commands. Implemented as per Version 1.0 and Document Rev 1.1.
 * @{
**/
#define  FRU_DEVICE_NOT_FOUND  0xCB
#define  FRU_NOT_ACCESSIBLE    0x81
#define  FRU_ACCESSIBLE        0x0

#define FRU_COMMON_HEADER_FORMAT_VERSION 0x01


extern int GetFRUAreaInfo ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int ReadFRUData ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);
extern int WriteFRUData ( uint8_t* pReq, uint8_t ReqLen,  uint8_t* pRes);

#endif /* FRU_H */
